		
		! Original Version for HP2000 by Tom Nelson sometime in the early 1980s.
		! This version for Clockwork Basic (c) Tom Nelson, 2002

		DIM x(100),y(100),sh(100),ty(100),tg(100)
		DIM E(6),T(2,6),O(8),G(8,8),P(10,10),Z(8,8)

		DEF FNY(D2)=COS(D2*0.785398163397448-0.785398163397448)		// Delta Y for course D2
		DEF FNX(D2)=-SIN(D2*0.785398163397448-0.785398163397448)	// Delta X for course D2
		
		DEF fnRnd(K)=INT(RND(1)*K)+1			// Random number from 1 to K
		DEF fnRndRng(A,B)=INT(RND(1)*(B-A+1))+A	// Random number from A to B

		DEF fnInGalaxy(X,Y)	  = X>=0.5 AND X<8.5  AND Y>=0.5 AND Y<=8.5
		DEF fnInQuadrant(X,Y) = X>=0.5 AND X<10.5 AND Y>=0.5 AND Y<=10.5
		DEF fnNearPlanet(X,Y) = (X>P1-3 AND X<P1+2) AND (Y>P2-3 AND Y<P2+2)
		DEF fnAtPlanet(X,Y)	  = (X=P1 OR X=P1-1) AND (Y=P2 OR Y=P2-1)
		DEF fnFac(token)= 10^(KF(token)-1)
		DEF fnObj(N,tk) = INT( (N-(INT(N/10^KF(tk))*10^KF(tk)))/10^(KF(tk)-1))
		DEF fnSeg(X,Y)  = (Q1=P1 AND Q2=P2)+(Q1=P1 AND Q2=P2-1)*2+(Q1=P1-1 AND Q2=P2)*3+(Q1=P1-1 AND Q2=P2-1)*4

		DEF fnCourseIJ(I,J) = ATN( (y(i)-y(j)) / (x(i)-x(j)) ) / 0.785398163397448 + 3 + (x(i)<x(j))*4

		DEF fnDist(X1,Y1,X2,Y2) = SQR((X1-X2)^2+(Y1-Y2)^2)	// Distance from X1,Y2 to X2,Y2
		DEF fnDistI(I,X,Y)=SQR((X(I)-X)^2+(Y(I)-Y)^2)		// Distance from object(I) to X,Y
		DEF fnDistIJ(I,J)=SQR((X(I)-X(J))^2+(Y(I)-Y(J))^2)	// Distance from object(i) to object(j)

		! Initialization
		READ V0$,V1$, U0$,U1$,U2$
		READ CLEAR$,HOME$,EOS$,EOL$
		READ GREY$,WHITE$,RED$,BLUE$,GREEN$,YELLOW$,CYAN$
		READ FLASH$,NOCURSOR$,CURSOR$

		! Superbee
		DATA "#,"'34'27"F"'34",3d,3d"		! Cursor to X,Y
		DATA "#,"'34'27"F"'34",3d,3d,a"		! Cursor to X,Y and print S$

		DATA '27"F044011"'27"K"
		DATA '27"F044009"
		DATA '27"F000013"

		DATA '27"E"			! Clear Screen
		DATA '27"H"			! Home Cursor
		DATA '27"J"			! Erase to End-of-screen
		DATA '27"K"			! Erase to End-of-line

		DATA '27"[1;30m", '27"[1;37;40m", '27"[1;31;40m", '27"[1;34;40m", '27"[1;32;40m", '27"[1;33;40m", '27"[1;36;40m"
		DATA '27"[0;47;30m", '27"[80m",   '27"[81m"

		NORMAL$='27"[0m"+WHITE$

		! Initialization
		DIM N$(10)
		FOR I=1 to 10
			READ N$(I)
		NEXT I
		DATA "Spock","Sulu","Chekov","Sulu","Spock","Spock","Chekov","Spock","Sulu","Chekov"
		
		// Ship Status (Condition)
		DIM Status$(4)
		READ GREEN,YELLOW,RED,DOCKED	// Enums
		FOR I=1 TO 4
			READ Status$(I)
		NEXT I
		DATA 1,2,3,4
		DATA " GREEN","YELLOW","   RED","DOCKED"

		DIM KF(8),KS$(8),KA$(8),PT(8),GT(8)

		READ EMPTYtk,ENTERPRISEtk,KLINGONtk,STARBASEtk,ASTEROIDtk,TRADERtk,PLANETtk,SHIELDtk	// Enums
		FOR I=1 TO 8
			READ KF(I),KS$(I),KA$(I)
		NEXT I

		DATA 1,2,3,4,5,6,7,8	// Must match indexes below

		DATA 9,"   ", '27"[1;37;40m"	// 1 Empty
		DATA 9,"~-~", '27"[1;33;40m"	// 2 Enterprise
		DATA 3,"/^\", '27"[1;31;40m"	// 3 Klingon
		DATA 2,">!<", '27"[1;32;40m"	// 4 Starbase
		DATA 9," + ", '27"[0;33;40m"	// 5 Asteroid
		DATA 1,"<T>", '27"[1;36;40m"	// 6 Trader
		DATA 5,"###", '27"[0;31;40m"	// 7 Planet
		DATA 9,":::", '27"[0;37;40m"	// 8 Planet Shields

		PRINT NORMAL$;

		L0=L1=0
		REPEAT
	 		PRINT CLEAR$;U2$;"Are you an expert at NCC1701? ";CURSOR$;
			LINPUT S$
			PRINT NOCURSOR$;

			SELECT UPS$(S$[1,1])
			CASE "Q"
				STOP
			CASE "Y"
				L0=3
			CASE "N"
				L0=1
//			CASE DEFAULT
//				L0=0
			ENDSELECT
		UNTIL L0<>0

StartGame:
		GOSUB Genesis
		GOSUB FillQuadrant
		GOSUB PaintScreen

		GOSUB TagAddress
		PRINT GREEN$"You must conquer the klingon planet in";
		PRINT USING "3d,"'34" stardates with"'34",2d,"'34" Starbases."'34;S9,GT(STARBASEtk)
		PRINT NORMAL$;

Cycle:
	 	GOSUB RealTime

		! Command Input
Prompt:
	 	GOSUB StatusUpdate
		PRINT
		PRINT U0$;"Orders :";CURSOR$;
		LINPUT I$
		PRINT NOCURSOR$;U1$;EOL$'10EOL$'10EOL$'13'10EOL$
		IF L1 THEN
			L1=0
			PRINT U2$;EOS$
		ENDIF

		S7=S7+0.05
		IF S7>S8+S9 THEN NoTimeLeft

		P0=((P0+(L0/50))*(P0<>0)) MIN 36
		IF NOT LEN(I$) THEN Cycle

		RESTORE CmdTable
NextCmd:
	 	S$=UPS$(I$)
		IF TYP(0)=3 THEN InvalidCommand
		READ S0$,C
		IF C=0 THEN InvalidCommand
		FOR D1=1 TO LEN(S0$)
			IF S$[D1,D1]<>S0$[D1,D1] THEN NextCmd
		NEXT D1
	 	GOSUB ParseToken
		I$=I$[D2+1+(D2<>LEN(I$))]

		GOSUB C OF TorpCmd,PhaserCmd,ProbeCmd,ShieldCmd,ConvertCmd,LongScanCmd,ShortScanCmd,MoveCmd,DockCmd,ConquerCmd,HelpCmd,QuitCmd,ComputerCmd,ImpoundCmd,TradeCmd ELSE CommandError
		GOTO Prompt

CommandError:
		PRINT "* Error in command; C=";c
		RETURN

InvalidCommand:
	 	PRINT U1$"Type ? for help"
		GOTO Prompt

QuitCmd:
		PRINT U2$;EOS$"The crew of the Enterprise is sorry to see you go!"
		STOP

		! "Command",Index#
CmdTable:
		DATA "TR",15			// Trade
		DATA "PHO",1,"T",1		// Photon/Torp
		DATA "PH",2,"F",2		// Phaser/Faser
		DATA "PR",3,"PO",3		// Probe/Pod
		DATA "SHO",7			// Short Scan
		DATA "SH",4				// Shields
		DATA "A",5				// Antimatter
		DATA "L",6				// Long Scan
		DATA "M",8,"N",8		// Move/Naviate
		DATA "DO",9				// Dock
		DATA "CON",10			// Conquer
		DATA "?",11,"H",11		// Help
	 	DATA "QUIT",12			// Quit
		DATA "COM",13,"CM",13	// Computer
		DATA "IM",14			// Impound					
		DATA "",0				// End of commands

		! RealTime Subroutine
RealTime:
	 	GOSUB StatusUpdate
		IF E(6)<1 THEN DeadInSpace	!!! DO NOT GOTO OUT OF SUBROUTINE !!!
		E(6)=(E(6)+(E(6)^1.01/1000)+0.005) MIN 1000

		GOSUB KlingonFiltering
		GOSUB ObjectMovement
		GOSUB ObjectsFire
		GOSUB KlingonProduction
		RETURN

		! Help Command
HelpCmd:
	 	PRINT U2$;EOS$"Options are:"
		PRINT "    PHaser,     Torp,       Probe"
		PRINT "    SHields,    CoMputer,   DOck"
		PRINT "    Long scan,  SHOrt scan"
		PRINT "    Antimatter conversion"
		PRINT "    Move or Navigate"
		PRINT "    TRade,      IMpound"
		PRINT "    CONquer (The Klingon planet)"
		PRINT "    Help,       QUIT"
		RETURN

		! Move Command
MoveCmd:
		S$="Course"
		GOSUB EnterCourse
		IF R9 THEN RETURN
		IF B<0.1 OR B>8 THEN
			PRINT U0$"Warp Factor :";CURSOR$;
			INPUT B							!!! MAKE THIS A SUBROUTINE !!!
			PRINT NOCURSOR$;

			IF B<0.1 OR B>8 THEN
				PRINT U1$"Checov: Impossible!"
				RETURN
			ENDIF
		ENDIF
	 	D1=20*B*(B<1)+10*2^(B-1)*(B>=1)
		IF D1>=E(6) THEN
			PRINT U1$"Scott: Insufficient antimatter."
			RETURN
		ENDIF
	 	E(6)=E(6)-D1
		GOSUB StatusUpdate
		GOSUB RealTime

		X=FNX(A); Y=FNY(A)
		X1=x(EI); Y1=y(EI)

		FOR I=1 TO INT(B*10)
			X0=X1+X
			Y0=Y1+Y
			IF NOT fnInQuadrant(X0,Y0) THEN 
				GOSUB NewQuadrant
				RETURN
			ENDIF
			IF P(X0,Y0)<>EMPTYtk THEN
				GOSUB SameQuadrant
				GOSUB Collision
				RETURN
			ENDIF
	 		X1=X0
			Y1=Y0
		NEXT I
		GOSUB SameQuadrant
		RETURN

SameQuadrant:
	 	X1=INT(X1+0.5)
		Y1=INT(Y1+0.5)
		I=EI
		GOSUB MoveObjectX1Y1

		IF Status=DOCKED THEN
			GOSUB FindBaseTarget	// I2
			IF fnDistIJ(EI,i2)>1.9 THEN	
				Status=GREEN
			ENDIF
		ENDIF
		RETURN

NewQuadrant:
		S1=x(EI); S2=y(EI)

	 	S1=S1+INT(X*((B-INT(B))*10)+0.5)
		S2=S2+INT(Y*((B-INT(B))*10)+0.5)

		Q1=Q1+INT(X*INT(B)+0.5)+(S1>10)-(S1<1)
		Q2=Q2+INT(Y*INT(B)+0.5)+(S2>10)-(S2<1)

		S1=S1+(S1<1)*10-(S1>10)*10
		S2=S2+(S2<1)*10-(S2>10)*10
		
		x(EI)=S1; y(EI)=S2

		Status=GREEN
		S7=S7+0.25
		IF S7>S8+S9 THEN NoTimeLeft
		GOSUB UpdateScreen

		RETURN

		! Enterprise Collision Subroutine
		! Inputs:	P(X0,Y0) - Collision Sector
		! Returns:	R9=1 - Collision, stop moving
Collision:
		SELECT P(X0,Y0)
		CASE 0
			PRINT "Oh No! NULL space!"
			STOP
		CASE EMPTYtk 	// No collision
			R9=0
			RETURN
		CASE ENTERPRISEtk 	// Enterprise
			PRINT "What!? Collided with ourself!"
			STOP
		CASE KLINGONtk
	 		IF B>=RND(1) THEN
				GOSUB TagAddress
				PRINT "Spock: Shields damaged in collision with Klingon!"

				H0=INT(RND(1)*500)*B
				GOSUB HitsOnEnterprise
				IF sh(ei)<0 THEN KilledByStupidity	

				H0=INT(RND(1)*H0)*B
				GOSUB FindTargetX0Y0	// I2
				GOSUB HitsOnKlingon
			ELSE
	 			GOSUB TagAddress
				PRINT "Chekov: Collision with Klingon averted!"
			ENDIF
		CASE STARBASEtk
	 		IF B>=RND(1) THEN
				GOSUB TagAddress
				PRINT "Spock: Shields damaged in collision with Starbase!"
	
				H0=INT(RND(1)*RND(1)*1000)*B
				GOSUB HitsOnEnterprise
				IF sh(ei)<0 THEN KilledByStupidity	

				H0=INT(RND(1)*H0)*B
				GOSUB FindTargetX0Y0	// I2
				GOSUB HitsOnBase
			ELSE
				PRINT USING V1$;35,23,"Spock: I barely managed to save the ship"
				PRINT USING V1$;35,24," and the Starbase from a fatal collision!"
				F0=F0+1
				IF F0>5 THEN BadNavigation
			ENDIF
		CASE ASTEROIDtk
			PRINT USING V1$;35,23,"Spock: I barely managed to save the ship"
			PRINT USING V1$;35,24,"   from being destroyed by that asteroid!"
			F0=F0+1
			IF F0>5 THEN BadNavigation
		CASE TRADERtk
	 		D1=RND(1)>0.5
			D1=A+2*(A<7 AND D1)-2*(A>2 AND  NOT D1)

			IF D1<>A AND B<=RND(1) THEN
				GOSUB FindObjectX0Y0	! I; Trader
				X1=INT(x(i)+FNX(D1)+0.5)
				Y2=INT(y(i)+FNY(D1)+0.5)
				IF fnInQuadrant(X1,Y1) THEN
					IF P(X1,Y1)=EMPTYtk THEN
						PRINT USING V1$;35,23,"Trader: HEY! Watch where you're going!"
						GOSUB Delay
						GOSUB MoveObjectX1Y1	// Move I to X1,Y1
						R9=0
						RETURN
					ENDIF
				ENDIF
			ELSE
	 			T8=1	// Hostile
				GOSUB TagAddress
				PRINT "Spock: Shields damaged in collision with Trader!"

				H0=INT(RND(1)*500)*B
				GOSUB HitsOnEnterprise
				IF sh(ei)<0 THEN KilledByStupidity	

				H0=INT(RND(1)*H0)*B
				GOSUB FindTargetX0Y0	! I2; Trader
				GOSUB HitsOnTrader
			ENDIF
		CASE PLANETtk,SHIELDtk
			PRINT USING V1$;35,23,"Spock: I barely managed to save the ship"
			PRINT USING V1$;35,24,"          from colliding with the planet!"
			F0=F0+1
			IF F0>5 THEN BadNavigation
		CASE DEFAULT
			PRINT "Hey!? What is this? P()=";P(X0,Y)
			STOP
		ENDSELECT

		R9=1	! Stop moving
		RETURN


		! Phaser Command
PhaserCmd:
	 	IF NOT PT(KLINGONtk) THEN
			PRINT U1$"No Klingons!"
			RETURN
		ENDIF
	 	GOSUB RealTime
		GOSUB Parse
		IF A<=0 OR A>E THEN
			PRINT U0$"No. of units to Phasers :";CURSOR$;
			INPUT A
			PRINT NOCURSOR$;
			IF A<0 OR A>E THEN RETURN
		ENDIF
	 	E=E-A
		GOSUB StatusUpdate

		nP=0	// Phaser Counter
		FOR i2=1 TO K5
			IF nP=6 THEN RETURN
			IF ty(i2)=KLINGONtk AND sh(i2)>=0 THEN
				H0=A/(PT(KLINGONtk) MIN 6)/fnDistIJ(EI,I2)
				GOSUB HitsOnKlingon
				nP=nP+1
			ENDIF
	 	NEXT I2
		RETURN

		! Torpedeo Command
TorpCmd:
	 	IF E<25 THEN
			PRINT U1$"Insufficient energy."
			RETURN
		ENDIF
	 	S$="Torp. Course"
		GOSUB EnterCourse
		IF R9 THEN RETURN

		GOSUB RealTime
		IF B<=0 THEN
			B=1
		ELSE
	 		IF NOT (B MIN 6<E/25) THEN
				PRINT U1$"Sulu: Only energy for"INT(E/10)"torps!"
				B=INT(E/10)
			ELSE
	 			IF B>=7 THEN
					PRINT U1$"Sulu: There are only 6 tubes!"
					B=6
				ENDIF
			ENDIF
		ENDIF
	 	S0$=YELLOW$+" :"
		I = EI	// Device Origin
		IA = A	// Device Course
		FOR D1=1 TO B MIN 6
			E=E-25
			GOSUB StatusUpdate
			GOSUB DeviceTrack
			IF R9 THEN
				GOSUB TorpedeoDamage
			ELSE
				GOSUB TagAddress
				PRINT "Sulu: Missed."
				RETURN
			ENDIF
	 	NEXT D1
		RETURN

		! Inputs:	I - Torpedeo Origin
TorpedeoDamage:
		H0=495+INT(RND(1)*10)
		SELECT P(X0,Y0)
		CASE 0
			PRINT "Sulu: Torpedeo hit NULL space!"
			STOP
		CASE ENTERPRISEtk
			GOSUB HitsOnEnterprise
			IF sh(ei)<0 THEN KilledByStupidity	
		CASE KLINGONtk
			GOSUB TagAddress
			PRINT "Sulu: Torpedo Hit!"
			GOSUB FindTargetX0Y0	// I2; Klingon
			GOSUB HitsOnKlingon
		CASE STARBASEtk
			GOSUB FindTargetX0Y0	// I2; Starbase
			GOSUB HitsOnBase
		CASE ASTEROIDtk
			IF I=EI THEN
				GOSUB TagAddress
				PRINT "Sulu: Torp wasted on asteroid."
			ENDIF
		CASE TRADERtk
			GOSUB TagAddress
			PRINT "Sulu: Trader Hit!"
			T8=1	// Hostile
			GOSUB FindTargetX0Y0	// I2; Trader
			GOSUB HitsOnTrader
		CASE PLANETtk
			GOSUB TagAddress
			PRINT "Sulu: Torp hit on planet!"
			GOSUB HitsOnPlanet
		CASE SHIELDtk
			GOSUB TagAddress
			PRINT "Sulu: Torp hit on planet shields!"
			GOSUB FindTargetX0Y0	// I2; Shield
			GOSUB HitsOnShield
		CASE DEFAULT
			PRINT "Sulu: Hit a bug! P()=";P(X0,Y0)
			STOP
		ENDSELECT
		RETURN

		! Probe Command
ProbeCmd:
	 	IF E<100 THEN 
			PRINT U1$"Scott: 100 energy units required!"
			RETURN
		ENDIF
	 	IF E(1)<=0 THEN
			PRINT U1$"Scott: No probes left!"
			RETURN
		ENDIF
	 	S$="Probe course"
		GOSUB EnterCourse
		IF R9 THEN RETURN
		IF B<10 OR B>E(6) THEN
			PRINT U0$"Number of Pods to fire :";CURSOR$;
			INPUT B
			PRINT NOCURSOR$;
			IF B<10 OR B>E(6) THEN RETURN
		ENDIF

		GOSUB RealTime

		E=E-100			// Energy units to launch
	 	E(6)=E(6)-B		// Antimatter
		E(1)=E(1)-1		// Probes
		GOSUB StatusUpdate
		S0$=YELLOW$+" o"
		I = EI	// Device Origin
		IA = A	// Device Course
		GOSUB DeviceTrack
		IF R9 THEN 
			GOSUB ProbeDamage
		ELSE
			GOSUB TagAddress
			PRINT "Sulu: Missed."
			RETURN
		ENDIF
		RETURN

		! Inputs:   B - Antimatter
		!		X0,Y0 - Sector hit
ProbeDamage:
		H1=B*25
		GOSUB TagAddress
		PRINT "Sulu: Probe contacted ";

		SELECT P(X0,Y0)
		CASE ENTERPRISEtk
			PRINT "the Enterprise!?"
			STOP
		CASE KLINGONtk
	 		PRINT "a Klingon."
			GOSUB FindTargetX0Y0	// I2; Klingon
			GOSUB DestroyKlingon
		CASE STARBASEtk
	 		PRINT "a Starbase!"
			GOSUB FindTargetX0Y0	// I2; Starbase
			GOSUB DestroyBase
		CASE ASTEROIDtk
	 		PRINT "an asteroid."
		CASE TRADERtk
	 		PRINT "the Trader."
			GOSUB FindTargetX0Y0	// I2; Trader
			GOSUB DestroyTrader
		CASE PLANETtk	! Only direct hits hurt planet
	 		PRINT "the Klingon planet."
			H0=H1
			GOSUB HitsOnPlanet
		CASE SHIELDtk
	 		PRINT "the shields of the Klingon planet."
			H0=H1
			GOSUB FindTargetX0Y0	// I2; Klingon
			GOSUB HitsOnShield
		CASE >SHIELDtk
			PRINT "an error. P()=";P(X0,Y0)
		ENDSELECT

	 	FOR I2=K5 TO 1 STEP -1	// I2 - Target
			IF sh(I2)>=0 AND (X0<>X(I2) OR Y0<>Y(I2)) THEN
				H0=H1/(fnDistI(I2,X0,Y0)+1)
				SELECT ty(i2)
				CASE ENTERPRISEtk
					IF Status<>DOCKED THEN
						GOSUB HitsOnEnterprise
						IF sh(ei)<0 THEN KilledByStupidity	
					ENDIF
				CASE KLINGONtk
					GOSUB HitsOnKlingon
				CASE TRADERtk
					GOSUB HitsOnTrader
				CASE STARBASEtk
					GOSUB HitsOnBase
				CASE SHIELDtk
					GOSUB HitsOnShield
				ENDSELECT
			ENDIF
	 	NEXT I2
		
		RETURN

		! Torp & Probe track subroutine
		! Inputs:	I  - Tracks from object
		!			IA - Direction
		! Returns:	R9 - 1: Hit
		!				 0: No hit
DeviceTrack:
	 	X=FNX(IA)
		Y=FNY(IA)
		X1=x(i)
		Y1=y(i)
	 	WHILE 1
			X1=X1+X
			Y1=Y1+Y
			X0=INT(X1+0.5)
			Y0=INT(Y1+0.5)
			IF NOT fnInQuadrant(X0,Y0) THEN	! Out of bounds
				R9=0
				RETURN
			ENDIF
			IF P(X0,Y0)<>EMPTYtk THEN
	 			R9=1
				RETURN
			ENDIF
			PRINT USING V1$;Y0*4-2,X0,S0$+NORMAL$
			GOSUB Delay
	 		PRINT USING V1$;Y0*4-2,X0,KA$(1)+KS$(1)+NORMAL$
		NEXT
		PRINT "Tracking Error!"
		STOP

		! Shield Command
ShieldCmd:
	 	GOSUB RealTime
		GOSUB Parse
		IF A<0 OR A>E+sh(ei) THEN
			PRINT U0$"Number of units to shields :";CURSOR$;
			INPUT A 
			PRINT NOCURSOR$
			IF A<0 OR A>E+sh(ei) THEN RETURN
		ENDIF

	 	E=E+sh(ei)-A
		sh(ei)=A
		Status=GREEN
		GOSUB StatusUpdate
		RETURN

		! Convert Antimatter Command
ConvertCmd:
	 	IF E<200 THEN
	 		PRINT U1$"Scott: 200 energy units need!"
			RETURN
		ENDIF
		GOSUB Parse
		IF A<1 OR A>E(6) THEN
			PRINT U0$"No. of Pods to convert :";CURSOR$;
			INPUT A
			PRINT NOCURSOR$
			IF A>E(6) OR A<=0 THEN RETURN
		ENDIF
	 	E(6)=E(6)-A
		E=INT(E+A*30)
		PRINT U1$"Scott: ";
		PRINT USING "5d,"'34" Energy units produced."'34;A*30
		RETURN

		! Docking Command
DockCmd:
	 	IF Status=DOCKED THEN
			PRINT U1$"McCoy: We're already docked!"
			RETURN
		ENDIF
	 	IF NOT PT(STARBASEtk) THEN
			PRINT U1$"Uhura: No Starbase in this quadrant."
			RETURN
		ENDIF
		GOSUB FindBase	// I; Starbase
	 	IF fnDistIJ(EI,I)>=1.9 THEN
			PRINT U1$"Scott: Starbase is out of range."
			RETURN
		ENDIF
	 	IF INT(sh(ei))>0 THEN
			PRINT U1$"Shields dropped for docking."
			E=sh(ei)+E
		ENDIF

	 	sh(ei)=0
		Status=DOCKED
		GOSUB StatusUpdate

		IF B5 THEN 
			IF E(6)<10 THEN E(6)=10
			PRINT U1$"Starbase: Welcome back, Captain!"
		ELSE
			B5=1	! Docked once flag
			E(1)=E(1) MAX 15
			E(6)=(E(6)+500) MIN 1000

			GOSUB StatusUpdate

			PRINT USING V1$;50,15,"Starfleet Command estimates"
			PRINT USING V1$;50,16,"you have "
			IF RND(1)<0.1 OR S9>=50 THEN
				PRINT "no ";
			ELSE
				D1=INT(RND(1)*3)+1
				PRINT USING "#,2d,x";D1
				S9=S9+D1
			ENDIF
	 		PRINT "extra stardates"
			PRINT USING V1$;50,17,"to complete your mission."
		ENDIF
	 	RETURN

		! Short range scan command
ShortScanCmd:
		PRINT CLEAR$;
		GOSUB PaintScreen
		RETURN

		! Long range scan command
LongScanCmd:
	 	D5=1
		PRINT USING V1$;62,D5,WHITE$+" Quadrant "
		D5=D5+1
		IF NOT fnInGalaxy(Q1,Q2) THEN
	 		PRINT YELLOW$;"UNKNOWN";
		ELSE
			PRINT USING "#,d,"'34","'34",d,4x";Q1,Q2
		ENDIF
	 	FOR X0=Q1-1 TO Q1+1
			PRINT USING V1$;62,D5,BLUE$+"-----+-----+-----"
			PRINT USING V0$;62,D5+1
			D5=D5+2
			FOR Y0=Q2-1 TO Q2+1
				D1=0
				PRINT GREY$".";
				IF fnInGalaxy(X0,Y0) THEN
					Z(X0,Y0)=G(X0,Y0)
					GOSUB PaintScan
				ELSE
					PRINT "....";
				ENDIF
				IF Y0<>Q2+1 THEN
					PRINT BLUE$"|";
				ENDIF
	 		NEXT Y0
			PRINT
		NEXT X0
		PRINT USING V1$;62,D5,BLUE$+"-----+-----+-----"
		PRINT NORMAL$;
		RETURN

		! Conquer Klingon Command
ConquerCmd:
	 	PRINT U2$;EOS$;
		IF fnObj(G(P1-1,P2-1),KLINGONtk) OR fnObj(G(P1-1,P2),KLINGONtk) OR fnObj(G(P1,P2-1),KLINGONtk) OR fnObj(G(P1,P2),KLINGONtk) THEN
	 		PRINT "You cannot conquer the klingon planet because"
			PRINT "it is still heavily defended by Klingon warships."
			RETURN
		ENDIF
	 	IF NOT P3 THEN
			PRINT "Spock: Suggest you go to the Klingon Planet to conquer it."
			RETURN
		ENDIF
	 	IF fnDistI(EI,P7,P8)>=2.8 THEN
			PRINT "Spock: We must orbit the Klingon planet to take control of it."
			RETURN
		ENDIF
		GOTO WinGame


		! Impound Command
ImpoundCmd:
	 	IF NOT PT(TRADERtk) THEN
			PRINT U1$"Uhura: No Trader in this quadrant."
			RETURN
		ENDIF
		IF  T8 THEN
			PRINT U1$"Uhura: The trader has not"U1$'10"       surrendered yet!"
			RETURN
		ENDIF
		GOSUB FindTraderInRange	// I
		IF I=0 THEN
			PRINT U1$"Scott: Trader is out of transporter"U1$'10"       range."
			RETURN
		ENDIF
		IF T(2,1) OR PT(TRADERtk) > 1 THEN
			PRINT U1$"Trader: Shove off buddy!"
			T8=RND(1)<sh(i)/5000
			RETURN
		ENDIF
	 	GOSUB TradeManifest
		IF R9 THEN
			PRINT U1$"Scott: The Trader doesn't have"U1$'10"       any cargo."
			RETURN
		ENDIF
	 	FOR n=1 TO 6
			E(n)=E(n)+T(1,n)
		NEXT n
		P=E(1)
		E=E(2)*50
		sh(i)=0
		MAT T=ZER
		PRINT U1$"Scott: Trader cargo transfered"U1$'10"       to the Enterprise."
		RETURN

		! Trade Command
TradeCmd:
	 	IF NOT PT(TRADERtk) THEN
	 		PRINT U1$"Uhura: No Trader in this quadrant."
			RETURN
		ENDIF
	 	IF T8 THEN
			PRINT U1$"Trader: I don't trade with tyrants!"
			RETURN
		ENDIF
	 	IF PT(KLINGONtk) THEN
			PRINT U1$"Trader: I'm not trading with"U1$'10"        Klingons around!"
			RETURN
		ENDIF
		GOSUB FindTraderInRange	// I
	 	IF I=0 THEN
	 		PRINT U1$"Scott: Trader is out of transporter"U1$'10"       range."
			RETURN
		ENDIF
		IF PT(TRADERtk)>1 THEN
			PRINT U1$"Trader: No time to trade now!"
			RETURN
		ENDIF
	 	GOSUB TradeManifest
		IF  R9 THEN
			PRINT U1$"Trader: You destroyed ALL of"U1$'10"        my cargo!"
			RETURN
		ENDIF

TradePrompt:
	 	PRINT USING V1$;0,20,"What have you got to trade?"+CURSOR$
		LINPUT S$
		PRINT NOCURSOR$;
		IF  NOT LEN(S$) THEN RETURN

		IF NOT PT(TRADERtk) THEN RETURN
		IF PT(KLINGONtk) THEN
	 		GOSUB TagAddress
			PRINT "Uhura: The Trader has cut off communications."
			RETURN
		ENDIF

		GOSUB TradeItem
		IF K=0 THEN TradePrompt
		eTI=K				// Item we have to trade
		IF E(eTI)<=0 THEN
			PRINT USING V0$;0,20
			PRINT EOS$'10"Scott: We don't have any "S1$"."
			GOTO TradePrompt
		ENDIF
	 	PRINT USING V0$;0,20
		PRINT EOS$"How many "S1$" to trade? ";
		INPUT D2
		eTO=INT(D2)			// Total Offered
		IF eTO<=0 THEN RETURN
		IF eTO>E(eTI) THEN
			PRINT USING V0$;0,20
			PRINT EOS$'10"Scott: We don't have that many."
			GOTO TradePrompt
		ENDIF
	 	PRINT USING V0$;0,20
		PRINT EOS$"What do you want for the "S1$"?";CURSOR$;
		LINPUT S$
		PRINT NOCURSOR$;
		IF  NOT LEN(S$) THEN RETURN
		GOSUB TradeItem
		IF K=0 THEN TradePrompt
		tRI=K			// Requested item from Trader
		IF T(1,tRI)<=0 THEN
			PRINT USING V0$;0,20
			PRINT EOS$'10"I haven't got any "S1$", stupid!"
			GOTO TradePrompt
		ENDIF
	 	eP=eTO*T(2,eTI)						// $ for Enterprise items
		tTM=INT(eP/T(2,tRI)) MIN T(1,tRI)	// Total Max items Trader will give
		IF tTM<1 OR eTI=tRI THEN
			PRINT USING V0$;0,20
			PRINT EOS$'10"Get lost!"
			GOTO TradePrompt
		ENDIF
	 	IF tRI=2 AND T(1,2)-tTM<=20 THEN	// 20 = 400/50
			tTM=T(1,2)-20
			IF tTM<1 THEN
				PRINT USING V0$;0,20
				PRINT EOS$'10"I refuse to deplete my fuel reserves any lower."
				GOTO TradePrompt
			ENDIF
		ENDIF
		tTO=INT(tTM)			// Total Trader Offer
		GOSUB Haggle

		TI=I	// Save I
	 	GOSUB RealTime
		I=TI	// Restore I
		GOTO TradeCmd

Haggle:
	 	PRINT EOL$"Is ";
		PRINT USING "#,4d,x";tTO
		PRINT S1$" enough? ";CURSOR$;
		LINPUT S$
		PRINT NOCURSOR$;
		SELECT UPS$(S$[1,1])
		CASE "N"
	 		IF tTO>=T(1,tRI) THEN
				PRINT USING V0$;0,20
				PRINT EOS$'10"That's all I've got!"
				RETURN
			ENDIF
	 		IF tTO>=tTM THEN
	 			PRINT USING V0$;0,20
				PRINT EOS$'10"That's my best offer..."
				RETURN
			ENDIF
			tTO=(tTO+INT(RND(1)*5)) MIN tTM
	 		PRINT USING V0$;0,21
			GOTO Haggle
		CASE "Y"
			GOSUB TradeIt
		CASE "F"	// Forget it
			GOSUB ForgetIt
		ENDSELECT
		RETURN

TradeIt:
	 	E(tRI)=E(tRI)+tTO
		E(eTI)=E(eTI)-eTO
		T(1,tRI)=T(1,tRI)-tTO
		T(1,eTI)=T(1,eTI)+eTO
		PRINT USING V0$;0,eTI+13
		PRINT USING "4d,7d";E(eTI),T(1,eTI)
		PRINT USING V0$;0,tRI+13
		PRINT USING "4d,7d";E(tRI),T(1,tRI)
ForgetIt:
	 	PRINT USING V0$;0,20
		PRINT EOS$
		E=E(2)*50
		sh(i)=T(1,2)*50
		RETURN


		! Trade Item Subroutine
TradeItem:
	 	S$=UPS$(S$)
		S0$="PFQTJA"
		RESTORE TradeLabels
		FOR K=1 TO 6
			READ S1$
			IF POS(S$[1,1],S0$[K,K]) THEN RETURN
		NEXT K
		K=0
		PRINT USING V0$;0,20
		PRINT '13'10"Type the initial of what you want."
	 	RETURN
TradeLabels:
	 	DATA "Probes","Fuel units","Bushels","Tribbles","Boxes","Pods"
		
		! Trading Manifest Subroutine
		! Inputs:  I - Slot of Trader
		! Returns: R9=1 - No items to trade
TradeManifest:
	 	IF T(1,1)+T(1,2)+T(1,3)+T(1,4)+T(1,5)+T(1,6)>0 THEN	
			RESTORE ManifestItems
			PRINT U2$;EOS$"ENT.   TRADER ITEM"
			E(2)=INT(E/50)
			T(1,2)=INT(sh(i)/50)
			FOR K=1 TO 6
				READ S$
				PRINT USING "4d,7d,2x,10a";E(K),T(1,K),S$
			NEXT K
			R9=0
		ELSE
	 		R9=1
		ENDIF
		RETURN
ManifestItems:
	 	DATA "Probes","Fuel units","Quatro","Tribbles","Jello","Antimatter"


		! Computer
ComputerCmd:
	 	I$=UPS$(I$)
		IF POS("GRSTC",I$[1,1])=0 THEN
			PRINT USING V1$;45,11,"Working:"+CURSOR$
	 		LINPUT I$
			PRINT NOCURSOR$;
			I$=UPS$(I$)
			IF  NOT LEN(I$) THEN RETURN
			PRINT
		ENDIF
	 	GOSUB POS("GRSTC?",I$[1,1]) OF GalaxyMapCmd,StatusReportCmd,StatusReportCmd,TorpDataCmd,CargoReportCmd,ComputerdHelp ELSE ComputerdHelp
		RETURN

ComputerdHelp:
		PRINT U2$;EOS$;
		FOR K=1 to K5
			PRINT k"="x(k);y(k)
		NEXT K
		RETURN

		PRINT U2$;EOS$"Options are: "
		PRINT "   Galactic record"
		PRINT "   Status Report"
		PRINT "   Cargo report"
		PRINT "   Targeting Data"
		RETURN

GalaxyMapCmd:
	 	PRINT U2$;EOS$;WHITE$"     1     2     3     4     5     6     7     8"
		FOR X0=1 TO 8
			PRINT USING "#,d,x";X0
			FOR Y0=1 TO 8
				IF X0=Q1 AND Y0=Q2 THEN
					PRINT GREEN$"E";
				ELSE
					PRINT GREY$".";
				ENDIF
				GOSUB PaintScan
				PRINT " ";
			NEXT Y0
			PRINT WHITE$
		NEXT X0
		PRINT NORMAL$;
		RETURN

StatusReportCmd:
	 	PRINT U2$;EOS$"      STATUS REPORT"
		PRINT USING "2d,3x,"'34"Klingon ships remaining"'34;GT(KLINGONtk)
		PRINT USING "2d,3x,"'34"Trader ships remaining"'34;GT(TRADERtk)
		PRINT USING "2d,3x,"'34"Starbases left"'34;GT(STARBASEtk)
		PRINT
		SELECT P0
		CASE >=1
			PRINT "The Klingon production rate is ";
			PRINT USING "2d,"'34" ships per stardate."'34;INT(P0)
		CASE >0
			PRINT "Klingon is below production level."
		CASE 0
	 		PRINT "Klingon production capability eliminated."
		ENDSELECT

	 	PRINT USING "#,"'34"There are "'34",2d";INT((S8+S9-S7)*10)/10
		PRINT " stardates until mission completion"
		IF  F0 THEN
			PRINT "Spock has saved the Enterprise ";
			PRINT USING "d,"'34" times."'34;F0
		ENDIF
		RETURN

	
		! Torpedoe Data Report Command
TorpDataCmd:
	 	IF K5<=EI THEN
			PRINT U1$"Nothing to target in this quadrant."
			RETURN
		ENDIF
	 	PRINT U2$;EOS$"     DIRECTION  DISTANCE  SHIELDS"
		FOR I=1 TO K5
			IF sh(I)>=0 AND I<>EI THEN
				D1=fnCourseIJ(EI,I)
				D2=fnDistIJ(I,EI)
				PRINT USING "2x,a,3x,3.2d,6x,3.2d,6x,4d";KA$(ty(i))+KS$(ty(i))+NORMAL$,D1,D2,sh(i)
			ENDIF
	 	NEXT I
		RETURN

		! Cargo Report Command
CargoReportCmd:
	 	PRINT U2$;EOS$" Cargo report"
		RESTORE ManifestItems
		E(2)=INT(E/50)
		FOR D1=1 TO 6
			READ S1$
			PRINT USING "#,4d,x";E(D1)
			PRINT S1$
		NEXT D1
		RETURN


		! Delay for output effects
Delay:
		Sleep 110		! In milliseconds
		RETURN

		! Short Pause for Message
ShortPause:
		Sleep 2000
		RETURN

		! Long Pause for Message
LongPause:
		Sleep 5000
		RETURN

		! Enter Course Subroutine
		! Inputs: S$ - Prompt
		!		  I$ - Current input
		! Returns: A - Course
		!		  R9 - 0 if valid
EnterCourse:
		GOSUB Parse
		IF A<=0 OR A>=9 THEN
			PRINT U0$;S$": ";CURSOR$;
			LINPUT I$ 
			PRINT NOCURSOR$;
			IF LEN(I$) THEN
				GOSUB Parse
				IF A<=0 OR A>=9 THEN
					PRINT U1$"Checov: What?"
	 				R9=1	// Invalid Course
					RETURN
				ENDIF
			ENDIF
		ENDIF
	 	R9=0	// Valid Course
		RETURN

		! Klingon Filtering Subroutine
KlingonFiltering:
		! Can not filter outside of the galaxy
		IF NOT fnInGalaxy(Q1,Q2) THEN RETURN
		! Not always and never on the first stardate
		IF RND(1)<=0.4 AND INT(S7)=S8 THEN RETURN

		K4=0	// Filter counter
		FOR X=Q1-1 MAX 1 TO Q1+1 MIN 8
			FOR Y=Q2-1 MAX 1 TO Q2+1 MIN 8
				IF PT(KLINGONtk)>=9 THEN RETURN	// Can't have more!
				nK = fnObj(G(X,Y),KLINGONtk) 

				// not Enterpise quadrant and at least one Klingon
				IF (X<>Q1 OR Y<>Q2) AND nK>=1 THEN
					// not planet qudrant or 4+ Klingon or Enterprise at planet and 2+ Klingon
					IF NOT fnAtPlanet(X,Y) OR nK>=4 OR (P3 AND nK>=2) THEN
	 					X0=(X<Q1)+(X>Q1)*10+(X=Q1)*(INT(RND(1)*10)+1)
						Y0=(Y<Q2)+(Y>Q2)*10+(Y=Q2)*(INT(RND(1)*10)+1)
						IF P(X0,Y0)=EMPTYtk THEN	// Entry sector is empty
							G(X,Y)=G(X,Y)-fnFac(KLINGONtk)
							G(Q1,Q2),Z(Q1,Q2)=G(Q1,Q2)+fnFac(KLINGONtk)

							D1=L0*100+L0*50*(fnDist(X,Y,P1,P2)<2.9)
							H0=D1+L0*200*((Y=P2-1 OR Y=P2) AND (X=P1-1 OR X=P1))
							ty=KLINGONtk
							GOSUB PlaceObject	// TY at X0,Y0; H0 Shields

							K4=K4+1
							IF K4=4 THEN FilterComplete
						ENDIF
					ENDIF
				ENDIF
	 		NEXT Y
		NEXT X

FilterComplete:
	 	IF  NOT K4 THEN RETURN
		IF K4>1 THEN	
			CONVERT K4 TO S$
			S1$="s"
		ELSE
	 		S$="A"
			S1$=" has"
		ENDIF
	 	GOSUB TagAddress
		PRINT "Spock: "RED$;S$" Klingon"S1$" entered the quadrant!"NORMAL$;
		GOSUB Delay
		RETURN


		! Object Movement Subroutine
ObjectMovement:
	 	KE=0	// Klingon Escaped Counter
		KT=PT(KLINGONtk)
		TE=0;	// Trader Escaped
		TT=PT(TRADERtk)
		FOR K=1 TO 3	// Number of moves per ship
			FOR I=1 TO K5	// Move each ship
				IF sh(I)>40 AND ty(i)<>STARBASEtk THEN	// Move mobile ships
					SELECT ty(i)
					CASE KLINGONtk
						IF sh(I)<=75+L0*10 THEN	// Escaping Ships
							GOSUB DecideEscapeSector	// D1,D2
							IF ABS(D1-X(I))>=ABS(D2-Y(I)) THEN	
								X0=X(I);Y0=D2
							ELSE
	 							X0=D1;Y0=Y(I)
							ENDIF
						ELSE	// Determine target
	 						IF PT(STARBASEtk) THEN
								GOSUB FindBaseTarget	// I2
								X0=x(i2);Y0=y(i2)
							ELSE
	 							IF PT(TRADERtk) AND NOT T8 THEN	// Friendly traders
									GOSUB FindTraderTarget	// I2	
									X0=x(i2);Y0=y(i2)
								ELSE
	 								X0=x(ei);Y0=y(ei)		// Enterprise
								ENDIF
							ENDIF
						ENDIF
						GOSUB ObjectMoves
						IF R9 THEN KE=KE+1

					CASE TRADERtk
						IF K=2 THEN
							IF PT(KLINGONtk) OR PT(TRADERtk)>1 OR T8 THEN
								// Always try to escape!
								GOSUB DecideEscapeSector	// D1,D2
								IF ABS(D1-X(I))>=ABS(D2-Y(I)) THEN	
									X0=X(I);Y0=D2
								ELSE
	 								X0=D1;Y0=Y(I)
								ENDIF
								GOSUB ObjectMoves
								IF R9 THEN TE=TE+1
							ELSE
								IF RND(1)<0.1 THEN
									X0=x(ei); Y0=y(ei)	// Enterprise
									GOSUB ObjectMoves
								ENDIF
							ENDIF
						ENDIF
					ENDSELECT
				ENDIF
	 		NEXT I
		NEXT K

		IF KE THEN
			IF KE>1 THEN
				CONVERT KE TO S$
				S1$="s"
			ELSE
				IF KT>1 THEN
					S$="A"
				ELSE
					S$="The"
				ENDIF
	 			S1$=""
			ENDIF
	 		GOSUB TagAddress
			PRINT "Spock: "RED$;S$" Klingon"S1$" escaped."NORMAL$
			GOSUB Delay
 		ELSE
			IF TE THEN
				IF TE>1 THEN
					CONVERT TE TO S$
					S1$="s"
				ELSE
					IF TT>1 THEN
						S$="A"
					ELSE
						S$="The"
					ENDIF
	 				S1$=" has"
				ENDIF
				GOSUB TagAddress
				PRINT "Spock: "CYAN$;S$" Trader"S1$" left the quadrant."NORMAL$
			ENDIF
		ENDIF
		RETURN 	


		! Move slot I object
		! Inputs:	I	  - Slot to move
		!			X0,Y0 - Destination Sector
		! Returns:	R9 - 0: No Move
		!				 1: Escaped
ObjectMoves:
		X1=X(I)
		Y1=Y(I)
		D1=fnDistI(I,X0,Y0)
		X=(X0-X1)/D1
		Y=(Y0-Y1)/D1

		IF fnInQuadrant(X1+X,Y1+Y) THEN
			IF  P(X1+X,Y1+Y)=EMPTYtk THEN	// Path is clear
				X1=X1+X
				Y1=Y1+Y
				GOSUB MoveObjectX1Y1
			ELSE
				IF RND(2)<=0.25 THEN	// Indicision
					GOSUB DecideDeltaX
					IF D1 AND ABS(X1-X0)<=ABS(Y1-Y0) THEN
						X1=X1+D1
						GOSUB MoveObjectX1Y1
					ELSE
						GOSUB DecideDeltaY
						IF D1 THEN
							Y1=Y1+D1
							GOSUB MoveObjectX1Y1
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			R9=0	// No Escape
		ELSE	// Escaped
			! Place in new quadrant
			X0=Q1-(X1+X<0.5)+(X1+X>10.5)
			Y0=Q2-(Y1+Y<0.5)+(Y1+Y>10.5)
			G(X0,Y0)=G(X0,Y0)+fnFac(ty(i))

			GOSUB EraseObject
			GOSUB RemoveObject 
								
			R9=1	// Escaped
		ENDIF
		RETURN

		! Returns D1 is X delta
DecideDeltaX:
		D1=1-(RND(1)>0.5)*2	// +1/-1
		IF (X1+D1>=0.5 AND X1+D1<=10.5) THEN
			IF P(X1+D1,Y1)=0 THEN
				RETURN
			ENDIF
		ENDIF
		D1=0;
		RETURN

		! Returns D1 is Y delta
DecideDeltaY:
		D1=1-(RND(1)>0.5)*2	// +1/-1
		IF Y1+D1>=0.5 AND Y1+D1<=10.5 THEN	
			IF P(X1,Y1+D1)=0 THEN	
				RETURN
			ENDIF
		ENDIF
		D1=0
		RETURN

		! Determine Target Escape Sector
		! Inputs:	    I - Object Slot
		! Returns:  D1,D2 - Target Sector
		!
DecideEscapeSector:
		D1=11*(Q1=1 OR (X(I)>=5 AND Q1<8))		// Go Right Flag
		D2=11*(Q2=1 OR (Y(I)>=5 AND Q2<8))		// Go Down Flag
		RETURN
		

		! Move slot Object I to X1,Y1
MoveObjectX1Y1:
		PRINT USING V1$;Y(I)*4-2,X(I),KA$(1)+KS$(1)+NORMAL$
		P(X(I),Y(I))=EMPTYtk

		X(I)=INT(X1+0.5)
		Y(I)=INT(Y1+0.5)
		P(X(I),Y(I))=ty(i)
		PRINT USING V1$;Y(I)*4-2,X(I),KA$(ty(i))+KS$(ty(i))+NORMAL$
		GOSUB Delay
		RETURN

		! Create/Draw Object 
		! Inputs:	TY - Object Type	
		!			H0 - Shields
		!		 X0,Y0 - Sector
PlaceObject:
		GOSUB CreateObject
		PRINT USING V1$;Y0*4-2,X0,KA$(ty)+KS$(ty)+NORMAL$
		RETURN

		! Remove Object I from Quadrant Subroutine
RemoveObject:
		P(X(I),Y(I))=EMPTYtk
		PT(ty(i))=PT(ty(i))-1
		G(Q1,Q2),Z(Q1,Q2)=G(Q1,Q2)-fnFac(ty(i))	// Remove from quadrant
		GOSUB FreeSlot
		RETURN

		! Remove/Explode Object I2 from Quadrant & Galaxy
DestroyTarget:
		GT(ty(i2))=GT(ty(i2))-1		// Less in galaxy
		GOSUB ExplodeTarget
		GOSUB RemoveTarget
		RETURN

		! Remove Target Object I2 from quadrant
RemoveTarget:
		P(X(I2),Y(I2))=EMPTYtk
		PT(ty(i2))=PT(ty(i2))-1		// Less in quadrant
		G(Q1,Q2),Z(Q1,Q2)=G(Q1,Q2)-fnFac(ty(i2))
		GOSUB FreeTargetSlot
		RETURN

		! Flash Screen Object
		! Inputs:	I2 - Object Slot
FlashTarget:
		PRINT USING V1$;y(i2)*4-2,x(i2),FLASH$+KS$(ty(i2))
		GOSUB Delay
	 	PRINT USING V1$;y(i2)*4-2,x(i2),KA$(ty(i2))+KS$(ty(i2))+NORMAL$
		RETURN

		! Flash and Erase Screen Object
		! Inputs:	I2 - Object Slot
ExplodeTarget:
		PRINT USING V1$;y(i2)*4-2,x(i2),FLASH$+KS$(ty(i2))
		GOSUB Delay
	 	PRINT USING V1$;y(i2)*4-2,x(i2),NORMAL$+"   "
		RETURN

		! Erase Screen Target
		! Inputs:	I2 - Object Slot
EraseTarget:
		PRINT USING V1$;Y(I2)*4-2,X(I2),KA$(1)+KS$(1)+NORMAL$
		RETURN

		! Erase Screen Object
		! Inputs:	I - Object Slot
EraseObject:
		PRINT USING V1$;Y(I)*4-2,X(I),KA$(1)+KS$(1)+NORMAL$
		RETURN

!! ** END of Movement Subroutines !!

		! Klingon Production Subroutine
KlingonProduction:
		IF  NOT INT(P0) OR S7-P9<1 THEN RETURN
		FOR D2=1 TO INT(P0)
			D1=1
KpAgain:	X0=P1-(P6>1 AND P6<4)
			Y0=P2-(P6>2)
			P6=(P6+1)*(P6<4)	// Which Planet segment
			IF fnInGalaxy(X0,Y0) THEN
				IF fnObj(G(X0,Y0),KLINGONtk)>=9 OR (X0=Q1 AND Y0=Q2) THEN
					IF D1=4 THEN RETURN
					D1=D1+1		// Count failed to place
					GOTO KpAgain
				ENDIF
	 			G(X0,Y0)=G(X0,Y0)+fnFac(KLINGONtk)
				GT(KLINGONtk)=GT(KLINGONtk)+1
				P9=S7
			ENDIF
	 	NEXT D2
		RETURN


		! Objects Fire Subroutine
ObjectsFire:
		F1=0
		FOR I=K5 TO 1 STEP -1
			IF sh(I)>0 THEN
				SELECT ty(i)
				CASE KLINGONtk
					GOSUB KlingonFire
					IF R9 AND NOT F1 THEN
						GOSUB TagAddress
						PRINT "Spock: Base shields protect us."
						F1=1
					ENDIF

				CASE STARBASEtk
					GOSUB StarbaseFire

				CASE TRADERtk
					GOSUB TraderFire
				ENDSELECT
			ENDIF
	 	NEXT I
		RETURN


		! Klingon Fires
		! Inputs:	I - Klingon Slot
		! Returns:	R9 - 0: Normal
		!				 1: Base shields protect us!
KlingonFire:
		R9=0
		// Target Starbase
	 	IF PT(STARBASEtk) THEN
			GOSUB FindBaseTarget	// I2
			D1=fnDistIJ(I,I2)
			IF D1<=4.9 THEN
				H0=sh(I)*3/D1
				GOSUB HitsOnBase
			ENDIF
			RETURN
		ENDIF
		// Target Trader
		IF PT(TRADERtk) AND NOT T8 THEN
			GOSUB FindTraderTarget	// I2
			H0=sh(i)*3/fnDistIJ(I,I2)
			T8=T8 OR RND(1)>0.85
			GOSUB HitsOnTrader
			IF NOT PT(TRADERtk) THEN
				GOSUB TagAddress
				PRINT "Spock: Trader destroyed by Klingon!"
			ENDIF
		ENDIF
		// Target Enterprise
	 	IF Status=DOCKED THEN
			R9=1
		ELSE
		 	H0=sh(I)*3/fnDistIJ(I,EI)
			GOSUB HitsOnEnterprise
			IF sh(ei)<0 THEN DestroyedByKlingons	
		ENDIF
		RETURN


		! Hit on Klingon Subroutine
		! Inputs:	I2 - Klingon Index
HitsOnKlingon:
		st=sh(i2)	// Temp
	 	sh(I2)=sh(I2)-H0
		IF sh(I2)<0 THEN
			GOSUB DestroyKlingon
		ELSE
			GOSUB FlashTarget
			IF st>40 AND sh(I2)<=40 THEN
	 			GOSUB TagAddress
				PRINT "Spock: ";RED$;
				PRINT USING '34"Klingon Immobilized at Sector "'34",2d,"'34","'34",2d,"'34"."'34;X(I2),Y(I2)
				PRINT NORMAL$
			ENDIF
			RETURN
		ENDIF
		RETURN

		! Destroy Klingon Subroutine
		! Inputs:	I2 - Klingon to destroy
DestroyKlingon:
		GOSUB DestroyTarget
		IF GT(KLINGONtk)=0 THEN
			GOSUB TagAddress
			PRINT "Spock: All Klingon ships have been destroyed."
			GOSUB TagAddress
			PRINT "       I suggest we go to the Klingon Planet and Conquer it!"
		ENDIF
	 	RETURN


		! Hits on Enterprise Subroutine
		!
		! Preserves: I2
		!
HitsOnEnterprise:
		IHSave=I2
		I2=EI
		sh(i2)=sh(i2)-H0
		GOSUB StatusUpdate
		IF sh(i2)<0 THEN 
			GOSUB DestroyEnterprise
		ELSE
			GOSUB FlashTarget
		ENDIF
		I2=IHSave
		RETURN

		! Blowup the Enterprise
		!
DestroyEnterprise:
		I2=EI
		FOR K=1 TO 4
			GOSUB ExplodeTarget
			GOSUB Delay
		NEXT K
		RETURN

		! Starbase Fires Subroutine
		! Entry: I - Base Slot
StarbaseFire:
		F2=0
		IF  NOT PT(STARBASEtk) THEN RETURN
		FOR I2=1 TO K5	// I2 - Target
			D1=fnDistIJ(I,I2)
			IF sh(i2)>=0 AND ty(i2)=KLINGONtk AND D1<=3.9 THEN
				IF NOT F2 THEN
					GOSUB TagAddress
					PRINT "Spock: Starbase firing on Klingons."
					F2=1
				ENDIF
	 			H0=sh(i)*2/D1
				GOSUB HitsOnKlingon
			ENDIF
	 	NEXT I2
		RETURN

		! Hits on Base
		! Inputs:  I2 - Slot of Base
HitsOnBase:
	 	sh(i2)=sh(i2)-H0
		IF sh(i2)<0 THEN
			GOSUB DestroyBase
		ELSE
			GOSUB FlashTarget

	 		CONVERT H0 TO S$
			GOSUB TagAddress
			PRINT "Spock: "S$" unit hit on Starbase."
	 		RETURN
		ENDIF
		RETURN

		! Destroy Base
		! Inputs:	I2 - Slot of base
DestroyBase:
		GOSUB ExplodeTarget
		GOSUB TagAddress
		PRINT "Spock: Starbase has been destroyed!"
		Status=GREEN	// will Recalc Status in case docked
		RETURN

		! Find Starbase Slot I
		! Returns: I
FindBase:
		ty=STARBASEtk
		GOSUB FindSlotTy
		RETURN

		! Find Starbase Target Slot I2
		! Returns: I2
FindBaseTarget:
		ty=STARBASEtk
		GOSUB FindTargetTy
		RETURN

		! Hit on Planet Shield Subroutine
		! Inputs:	I2 - Klingon Index
HitsOnShield:
		st=sh(i2)	// Temp
	 	sh(I2)=sh(I2)-H0
		IF sh(I2)<0 THEN
			GOSUB DestroyShield
		ELSE
			GOSUB FlashTarget
		ENDIF
		RETURN

		! Destroy Planet Shield
DestroyShield:
		GOSUB DestroyTarget
		RETURN

		! Hits on Planet Subroutine
		! 
HitsOnPlanet:
		PRINT USING V1$;Y0*4-2,X0,FLASH$+KS$(PLANETtk)
		GOSUB Delay
		PRINT USING V1$;Y0*4-2,X0,KA$(PLANETtk)+KS$(PLANETtk)+NORMAL$

	 	IF P0 THEN
			P0=P0-H0/500 MAX 0
			IF NOT P0 THEN
				FOR I2=1 TO K5	! Remove the shields
					IF ty(I2)=SHIELDtk AND sh(i2)>=0 THEN
						GOSUB EraseTarget
						GOSUB RemoveTarget
					ENDIF
				NEXT I2
				GOSUB TagAddress
				PRINT "Spock: Klingon production capability destroyed!"
			ENDIF
		ENDIF
	 	RETURN

		! Trader Actions Subroutine
		! Entry:	I - Trader Slot
TraderFire:
	 	IF  NOT T8 THEN RETURN	// Not hostile
		IF Status=DOCKED THEN
			GOSUB TagAddress
			PRINT "Spock: Starbase shields protect us from trader."
		ELSE
			S0$=CYAN$+" :"
			IA=fnCourseIJ(I,EI)
			GOSUB DeviceTrack	// Course IA from I
			IF R9 THEN
				GOSUB TorpedeoDamage
			ENDIF

	 	//	H0=T4/fnDistIJ(I,EI)
		//	GOSUB HitsOnEnterprise
		//	IF sh(ei)<0 THEN KilledByStupidity	
		//	CONVERT H0 TO S$
		//	GOSUB TagAddress
		//	PRINT "Spock: "S$" unit hit from Trader."
		ENDIF
	 	RETURN

		! Hits on Trader Subroutine
		! Inputs:	I2 - Index of Trader
HitsOnTrader:
		st=sh(i2)	// Temp
	 	sh(i2)=sh(i2)-H0
		IF sh(i2)<0 THEN 
			GOSUB DestroyTrader
		ELSE
			GOSUB FlashTarget
			IF st>40 AND sh(I2)<=40 THEN
	 			GOSUB TagAddress
				PRINT "Spock: ";CYAN$;
				PRINT USING '34"Trader Immobilized at Sector "'34",2d,"'34","'34",2d,"'34"."'34;X(I2),Y(I2)
				PRINT NORMAL$
			ENDIF
			FOR D2=1 TO 6	// Destroy some cargo!
				T(1,D2)=INT(T(1,D2)*(RND(1) MAX 0.2))
			NEXT D2
			IF st>=400 AND sh(i2)<400 THEN
				GOSUB TagAddress
				PRINT "Uhura: Trader is surrendering."
				FOR D2=1 TO 6
					T(2,D2)=0
				NEXT D2
				T8=0	// Not hostile
			ENDIF
		ENDIF
	 	RETURN

		! Destroy Trader I2
DestroyTrader:
		GOSUB DestroyTarget
		RETURN

		! Find Trader Slot I
FindTrader:
		ty=TRADERtk
		GOSUB FindSlotTy
		RETURN

		! Find Trader Slot I in Transporter Range of Enterprise
		!
FindTraderInRange:
		FOR I=1 TO K5
	 		IF ty(I)=TRADERtk AND fnDistIJ(EI,i)<3 THEN RETURN
		NEXT I
		I=0
		RETURN

		! Find Trader Target I2
FindTraderTarget:
		ty=TRADERtk
		GOSUB FindTargetTy
		RETURN

		! Update Short Scan Subroutine
UpdateScreen:
	 	FOR D1=1 TO 10
			FOR D2=1 TO 10
				IF P(D1,D2) THEN
					PRINT USING V1$;D2*4-2,D1,KA$(1)+KS$(1)+NORMAL$
				ENDIF
 			NEXT D2
		NEXT D1
		GOSUB FillQuadrant
		PRINT U2$;EOS$
		F4=0
		FOR D1=1 TO 10
			FOR D2=1 TO 10
				IF  P(D1,D2) THEN
					PRINT USING V1$;D2*4-2,D1,KA$(P(D1,D2))+KS$(P(D1,D2))+NORMAL$
				ENDIF
	 		NEXT D2
		NEXT D1
		RETURN


		! PaintScan Subroutine
		! Inputs:	X0,Y0
		!			Z()
PaintScan:
	 	IF fnOBJ(Z(X0,Y0),KLINGONtk) THEN
			PRINT RED$;DEC$(fnOBJ(Z(X0,Y0),3));
		ELSE
			PRINT GREY$".";
		ENDIF
 		IF fnOBJ(Z(X0,Y0),STARBASEtk) THEN
			PRINT GREEN$"B";
		ELSE
			PRINT GREY$".";
		ENDIF
	 	IF fnOBJ(Z(X0,Y0),TRADERtk) THEN
			PRINT CYAN$"T";
		ELSE
			PRINT GREY$".";
		ENDIF
	 	IF fnAtPlanet(X0,Y0) THEN
			PRINT RED$"K";
		ELSE
			PRINT GREY$".";
		ENDIF
		PRINT NORMAL$;
	 	RETURN

		! Position Cursor to "next" line for message.
TagAddress:
		PRINT USING V1$;0,L1+13
		IF NOT L1 THEN
	 		PRINT EOS$;
		ENDIF
	 	L1=L1+1
		IF L1>9 THEN
			L1=0
		ENDIF
	 	RETURN

		! Parse I$ Subroutine
		!
		! Inputs:	I$ - Command line
		! Outputs:	A - Numeric Argument 1
		!			B - Numeric Argument 2
Parse:
		GOSUB ParseToken
		CONVERT I$[1,D2] TO A,NotNumericA
		GOTO TryNumericB
NotNumericA:
	 	A=-1
TryNumericB:
		IF D2=LEN(I$) THEN NotNumericB
		CONVERT I$[D2+2] TO B,NotNumericB
		RETURN
NotNumericB:
	 	B=-1
	 	RETURN

ParseToken:
	 	S1$=" -,;:/\_"	// Delimiters
		FOR D1=1 TO 8
			D2=POS(I$,S1$[D1,D1])
			IF D2 THEN 
				D2=D2-1
				RETURN
			ENDIF
		NEXT D1
		D2=LEN(I$)
	 	RETURN

		! Update Status

StatusUpdate:
		! Stardate
		IF INT(S7*10)<>INT(O(1)*10) THEN
			PRINT USING V0$;55,1
			PRINT USING "4.1D";S7
			O(1)=S7
		ENDIF

		! Status
		GOSUB CheckStatus
	 	IF Status<>O(8) THEN
			PRINT USING V0$;55,2
			PRINT Color$;Status$(Status);NORMAL$
			O(8)=Status
		ENDIF
		
		! Quadrant
	 	IF Q1<>O(2) OR Q2<>O(3) THEN
			PRINT USING V0$;54,3
			IF NOT fnInGalaxy(Q1,Q2) THEN
	 			PRINT YELLOW$"UNKNOWN"NORMAL$
			ELSE
				PRINT USING "3x,2d,"'34","'34",d";Q1,Q2
			ENDIF
			O(2)=Q1
			O(3)=Q2
		ENDIF

		! Energy
	 	IF E<>O(4) THEN
			PRINT USING V0$;55,4
			PRINT USING "6d";E
			O(4)=E
		ENDIF

		! Probes
	 	IF E(1)<>O(5) THEN
			PRINT USING V0$;56,5
			PRINT USING "5d";E(1)
			O(5)=E(1)
		ENDIF

		! Shields
	 	IF sh(ei)<>O(6) THEN
			PRINT USING V0$;55,6
			PRINT USING "6d";sh(ei)
			O(6)=sh(ei)
		ENDIF

		! Antimatter
		IF E(6)<>O(7) THEN
			PRINT USING V0$;56,7
			PRINT USING "5d";E(6)
			O(7)=E(6)
		ENDIF

	 	RETURN


		! PaintScreen Subroutines
PaintScreen:
	 	PRINT HOME$;BLUE$;
		PRINT USING '34"+"'34"10("'34" ---"'34"),"'34" +"'34
		FOR X0=1 TO 10
			PRINT "| ";
			FOR Y0=1 TO 10
				PRINT KA$(P(X0,Y0));KS$(P(X0,Y0));" ";
	 		NEXT Y0
			PRINT BLUE$;"| ";WHITE$;
			SELECT X0
			CASE 1
				PRINT USING '34"Stardate"'34",3x,4.1d";S7
				O(1)=S7
			CASE 2
				GOSUB CheckStatus
				PRINT USING '34"Condition"'34",2x,a,6a";color$,Status$(Status)
				O(8)=Status
			CASE 3
				PRINT "Quadrant ";
				IF NOT fnInGalaxy(Q1,Q2) THEN
					PRINT YELLOW$"UNKNOWN"NORMAL$
				ELSE
					PRINT USING "5x,d,"'34","'34",d";Q1,Q2
				ENDIF
				O(2)=Q1;O(3)=Q2
			CASE 4
				PRINT USING '34"Energy"'34",5x,6d";E
				O(4)=E
			CASE 5
				PRINT USING '34"Probes"'34",6x,5d";E(1)
				O(5)=E(1)
			CASE 6
				PRINT USING '34"Shields"'34",4x,6d";sh(EI)
				O(6)=sh(EI)
			CASE 7
				PRINT USING '34"Antimatter  "'34",5d";E(6)
				O(7)=E(6)
			CASE >=8
				PRINT
			ENDSELECT
			PRINT BLUE$;
	 	NEXT X0
		PRINT USING '34"+"'34"10("'34" ---"'34"),"'34" +"'34
		PRINT NORMAL$;
		RETURN

		! Sets Status Color$ string
CheckStatus:
	 	IF Status=DOCKED THEN
			Color$=BLUE$
		ELSE
			IF PT(KLINGONtk)>0 THEN
				Status=RED; Color$=RED$
			ELSE
				IF E+sh(ei)<5000 OR sh(ei)<1000 OR (PT(TRADERtk) AND T8) THEN
	 				Status=YELLOW; Color$=YELLOW$
				ELSE
					Status=GREEN; Color$=GREEN$
				ENDIF
			ENDIF
		ENDIF
		RETURN


		! Fill New Quadrant Subroutine
		! Input: Q1,Q2 - Enterprise Quadrant
		!		 EI    - Enterprise Object
		!		 L0	   - Expert Level
		!		 G()   - Galaxy Contents
		! Output: A pile of quadrant stuff
		!
		! Quadrant Contents in P(x,y) contain tokens to indicate object.
		!	1 - Enterprise;	2 - Klingon;	3 - Starbase
		!	4 - Astroid		5 - Trader;		6 - Klingon Planet
		!	7 - Planet Shield
FillQuadrant:
	 	B5=0	! Docked once
		T8=0	! Hostile Trader
		P3=0	! Planet 

		MAT P=(EMPTYtk)	! Quadrant Content
		MAT PT=ZER		! Quadrant Total(ty)
		GOSUB PurgeSlots

		P(x(EI),y(EI))=ENTERPRISEtk

		! Do nothing if outside the galaxy
		IF NOT fnInGalaxy(Q1,Q2) THEN RETURN

		! Place planet segment
		IF (fnAtPlanet(Q1,Q2)) THEN
			SELECT fnSeg(Q1,Q2)
			CASE 1
				P(1,1),P(1,2),P(2,1)=PLANETtk
				P7,P8=1
				IF P0 THEN
					H0=10000*L0
					ty=SHIELDtk
					RESTORE Seg1Shield
					GOSUB CreateDataObject
					X0,Y0=3
				ELSE
					X0,Y0=2
				ENDIF
Seg1Shield:		DATA 1,3, 2,2, 2,3, 3,1, 3,2
				DATA 0
	 		CASE 2
				P(1,9),P(1,10),P(2,10)=PLANETtk
				P7=1;P8=10
				IF P0 THEN
					H0=10000*L0
					ty=SHIELDtk
					RESTORE Seg2Shield
					GOSUB CreateDataObject
					X0=3;Y0=8
				ELSE
					X0=2;Y0=9
				ENDIF
Seg2Shield:		DATA 1,8, 2,8, 2,9, 3,9, 3,10
				DATA 0
			CASE 3
				P(9,1),P(10,1),P(10,2)=PLANETtk
				P7=10;P8=1
				IF P0 THEN
					H0=10000*L0
					ty=SHIELDtk
					RESTORE Seg3Shield
					GOSUB CreateDataObject
					X0=8;Y0=3
				ELSE
					X0=9;Y0=2
				ENDIF
Seg3Shield:		DATA 8,1, 8,2, 9,2, 9,3, 10,3
				DATA 0
			CASE 4
				P(9,10),P(10,9),P(10,10)=PLANETtk
				P7,P8=10
				IF P0 THEN
					H0=10000*L0
					ty=SHIELDtk
					RESTORE Seg4Shield
					GOSUB CreateDataObject
					X0,Y0=8
				ELSE
					X0,Y0=9
				ENDIF
Seg4Shield:		DATA 8,9, 8,10, 9,8, 9,9, 10,8
				DATA 0
			ENDSELECT
			P3=1
	 		IF P(x(EI),y(EI))<>ENTERPRISEtk THEN
				x(EI)=X0; y(EI)=Y0
				P(x(EI),y(EI))=ENTERPRISEtk;
			ENDIF
		ENDIF

		D2=RND(1)	! Save RND sequence

		! Place Astroids
		nO=INT(RND(-(Q1*9+Q2))*4)+1	! Seed RND with quadrant
	 	FOR D1=1 TO nO
			GOSUB RandomSector
			P(X0,Y0)=ASTEROIDtk
		NEXT D1

		! Place Starbase
		nO=fnOBJ(G(Q1,Q2),STARBASEtk)
		IF nO THEN
			H0=5000
			ty=STARBASEtk
			GOSUB CreateObjectRandom
		ENDIF

		D2=RND(-D2)	! Restore RND sequence

		! Place Trader
		nO=fnOBJ(G(Q1,Q2),TRADERtk)
		IF nO THEN 
			FOR D1=1 TO nO
				H0=1750+INT(RND(1)*500)
				ty=TRADERtk
				GOSUB CreateObjectRandom
			NEXT D1
			T8=RND(1)>(E+sh(EI))/10000	// Hostile
			FOR D1=1 TO 6	! Give cargo
				T(1,D1)=INT(RND(1)*100)+10				// Quantity
				IF D1=2 THEN T(1,D1)=sh(i)/50
				T(2,D1)=(100+INT(RND(1)*10))/T(1,D1)	// Price. More means cheaper
			NEXT D1
		ENDIF

		! Place Klingon Ships
	 	nO=fnOBJ(G(Q1,Q2),KLINGONtk)
		IF nO THEN
			IF sh(EI)<=500*nO THEN
				PRINT U1$;RED$"SHIELDS ARE INSUFFICIENT!!"NORMAL$
			ENDIF
			FOR D1=1 TO nO
				D3=L0*100+L0*50*(fnDist(Q1,Q2,P1,P2)<2.9)
				H0=D3+L0*200*fnAtPlanet(Q1,Q2)
				ty=KLINGONtk
				GOSUB CreateObjectRandom
			NEXT D1
		ENDIF
	 	RETURN

		! Create Object in Quadrant
		! Inputs:	TY - Type of Object
		!			H0 - Shields of Object
		!			X0,Y0 - Sector of Object
CreateObject:
		GOSUB AllocSlot	// I
		ty(i)=ty
		sh(i)=H0
		x(i)=X0; y(i)=Y0; 
		P(x0,y0)=ty
		pt(ty)=pt(ty)+1	// Quadrant Total
		RETURN

		! Randomly Create Object
		! Inputs:	TY - Type of Object
		!			H0 - Shields
CreateObjectRandom:
		GOSUB RandomSector	// X0,Y0
		GOSUB CreateObject
		RETURN

		! Create many objects from Data Statement
		! Restore Data before calling.
		! Inputs:	TY - Object Type
		!			H0 - Object Shields
		!			DATA X,Y	- X,Y list. Stops when X is 0.
		!	
CreateDataObject:
		REPEAT
			READ x0
			IF x0<>0 THEN
				READ y0
				GOSUB CreateObject
			ENDIF
		UNTIL x0=0
		RETURN


		! Generate Random Sector
		! Output: X0,Y0
RandomSector:
		REPEAT
			X0=INT(RND(1)*10)+1
			Y0=INT(RND(1)*10)+1
		UNTIL P(X0,Y0) = EMPTYtk
		RETURN

		! Find Slot for Object Subroutine
		!
		! Returns: I - Empty Object Index
		!			   or Zero if no slot available.
AllocSlot:
		FOR I=1 TO 100
			IF sh(I)<0 THEN 
				K5=K5 MAX I		! Highest slot in use
				RETURN
			ENDIF
		NEXT I
		PRINT "ERROR: No available slots!"
		STOP
		I=0
		RETURN
		
		! Free Slot I
FreeSlot:
		sh(I)=-1
		K5=K5-(I=K5)	! Highest slot in use
		RETURN

		! Free Target Slot I2
FreeTargetSlot:
		sh(I2)=-1
		K5=K5-(I2=K5)	! Highest slot in use
		RETURN

		! Free all slots except Enterprise (EI)
PurgeSlots:
		FOR K=1 TO K5
			IF K<>EI THEN
				sh(K)=-1
			ENDIF
		NEXT K
		RETURN

		! Find Object Slot Index Subroutine
		!
		! Inputs:	X0,Y0 - Ship to find
		! Returns:	I - Index of Ship
FindObjectX0Y0:
	 	FOR I=1 TO K5
			IF sh(I)>=0 THEN
				IF X(I)=INT(X0+0.5) AND Y(I)=INT(Y0+0.5) THEN RETURN
			ENDIF
	 	NEXT I
		PRINT "ERROR: Could not find ship at "X0","Y0
		STOP

		! Find Target Object Slot Index Subroutine
		!
		! Inputs:	X0,Y0 - Ship to find
		! Returns:	I2 - Index of Ship
FindTargetX0Y0:
	 	FOR I2=1 TO K5
			IF sh(I2)>=0 THEN
				IF X(I2)=INT(X0+0.5) AND Y(I2)=INT(Y0+0.5) THEN RETURN
			ENDIF
	 	NEXT I2
		PRINT "ERROR: Could not find target ship at "X0","Y0
		STOP

		! Find Object Slot Index by Type Subroutine
		!
		! Inputs:	Ty - Type of Ship to find
		! Returns:	I - Index of Ship
FindSlotTy:
	 	FOR I=1 TO K5
			IF sh(I)>=0 THEN
				IF ty(i)=ty THEN RETURN
			ENDIF
	 	NEXT I
		PRINT "ERROR: Could not find ship type "ty
		STOP

		! Find Target Object Slot Index by Type Subroutine
		!
		! Inputs:	Ty - Type of Ship to find
		! Returns:	I2 - Index of Ship
FindTargetTy:
	 	FOR I2=1 TO K5
			IF sh(I)>=0 THEN
				IF ty(i2)=ty THEN RETURN
			ENDIF
	 	NEXT I2
		PRINT "ERROR: Could not find ship type "ty
		STOP


		! Fill the galaxy
		! Input:  L0 - Expert Level
		! Output: Most everything
Genesis:
	 	I,I2,K5,F0,P6,P7,P8=0
		P9,S8,S7=INT(RND(1)*20+20)*100
		S9=INT(RND(1)*6)+25
		P0=0.75
		P1,P2=5
		P6=1

		MAT G=ZER	! Galaxy Context
		MAT T=ZER	! Trader Cargo
		MAT X=ZER	! Object X
		MAT Y=ZER	! Object Y
		MAT SH=(-1)	! Object Shields
		MAT TY=ZER	! Object Type
		MAT Z=ZER	! Galaxy Map
		MAT PT=ZER	! Quadrant Total(ty)
		MAT GT=ZER	! Galaxy Total(ty)

		MAT E=ZER	! Enterprise Cargo
		MAT O=ZER	! Status Display flags
		E=50000		! Energy
		E(1)=15		! Probes
		E(6)=500	! Antimatter
		Status=GREEN

		! Place the Enterprise along the rim of the Galaxy.
	 	D1=RND(1)
		D2=RND(1)
		Q1=(D1>0.5)*(INT(RND(1)*6)+2)+(D1<0.5)*((D1>0.25)+(D1<0.25)*8)
		Q2=((Q1>1 AND Q1<8)*((D1<0.75)+(D1>0.75)*8))
		Q2=Q2+((Q1=1 OR Q1=8)*(INT(D2*6)+2))

		X0=INT(RND(1)*10)+1	! Enterprise Sector X
		Y0=INT(RND(1)*10)+1	! Enterprise Sector Y

		H0=0
		ty=ENTERPRISEtk
		GOSUB CreateObject	// at X0,Y0 H0 shields
		EI=I				// Save Enterprise Index

		FOR X=1 TO 8
			FOR Y=1 TO 8
				// Klingons only near planet
				K3=fnNearPlanet(X,Y)*2	// +2 Klingons near planet
				K3=K3+fnAtPlanet(X,Y)*2	// +2 Klingons at planet
				GT(KLINGONtk)=GT(KLINGONtk)+K3
				G(X,Y)=G(X,Y)+K3*fnFac(KLINGONtk)	// Place Klingons

				// Traders anywhere except initial Enterprise Quadrant
				T3=(X<>Q1 OR Y<>Q2) AND RND(1)>0.65
				GT(TRADERtk)=GT(TRADERtk)+T3
				G(X,Y)=G(X,Y)+T3*fnFac(TRADERtk)	// Place Traders
			NEXT Y
		NEXT X

		GT(STARBASEtk)=3+(L0=1)*4
		FOR K=1 TO GT(STARBASEtk)
			! Bases only on the rim
			REPEAT
				IF RND(1)>0.5 THEN
					X=fnRndRng(1,8)
					Y=(RND(1)>0.5)*7+1
				ELSE
					X=(RND(1)>0.5)*7+1
					Y=fnRndRng(1,8)
				ENDIF
			UNTIL fnObj(G(X,Y),STARBASEtk)=0
			Z(X,Y),G(X,Y)=G(X,Y)+fnFac(STARBASEtk)
		NEXT K
		RETURN

		! End Game; Dead in space. 
DeadInSpace:
	 	L5=1
		GOTO LoseGame

		! End Game; No Time Left.
NoTimeLeft:
	 	L5=2
		GOTO LoseGame

		! End Game; Destroyed by Klingons
DestroyedByKlingons:
	 	L5=3
		GOTO LoseGame

BadNavigation:
		L5=4
		GOTO LoseGame

		! End Game; Killed by collision, etc.
KilledByStupidity:
	 	L5=5
		GOTO LoseGame


		! End Game; WIN!
WinGame:
	 	PRINT U2$;EOS$"You have conquered the Klingon Planet!"
		PRINT "  The Galaxy is safe for Democracy!"
		GOSUB ShortPause
		PRINT '13'10"Uhura: Incoming message from Starfleet Command..."
		GOSUB ShortPause
		PRINT '13'10"They are commending you on your fine performance"
		PRINT "against the Klingons.  Congratulations Captain!"
		GOSUB LongPause
PlayAgain:
		PRINT
		PRINT CLEAR$;U2$"Are you prepared for another mission?";CURSOR$;
		LINPUT S$
		PRINT NOCURSOR$;
		IF POS("Yy",S$[1,1]) THEN StartGame
		PRINT "   The crew of the Enterprise is sorry to see you go."
		STOP

EndMessages:
	 	DATA "The Enterprise is dead in space","All hope of rescue is in vain!"
		DATA "The Enterprise was unable to Conquer Klingon in time"
		DATA "Earth is being overrun by Klingon spies!"
		DATA "The Enterprise has been DESTROYED!"
		DATA "Earth's last hope of deliverance is gone!"
		DATA "First Officer Spock has been promoted to Captain"
		DATA "Because of his obvious superiority in navigation."
		DATA "Wreckage of the USS Enterprise has been reported by a Trader."
		DATA "Obviously due to gross negligence."

		! End Game Status
		! L5 - Message Number
LoseGame:
	 	PRINT U2$;EOS$"Starfleet Command Reports:"
		GOSUB ShortPause
		RESTORE EndMessages
		FOR D1=1 TO L5
			READ S$,S0$
		NEXT D1
		PRINT "   "S$
		PRINT "   "S0$
		GOSUB ShortPause
		PRINT '10"There are still"GT(KLINGONtk)"Klingon battle cruisers."
		GOSUB LongPause
		GOTO PlayAgain

		END
